<%- include('../partials/header') %>
<%- include('../partials/scripts') %>
<%- include('../partials/select2') %>
</head>

<body class="min-vh-100 d-flex flex-column">
	<%- include('../partials/navbar') %>
	<div class="main-content d-flex flex-column flex-grow-1">
		<%- include('../partials/topbar') %>
		<%- include('./header', { active: 'edit' }) %>
		<!-- Page content -->
		<div class="container-fluid mt--7 flex-grow-1">
			<div class="row">
				<div class="col-xl-12">
					<div class="card">
						<div class="card-header">
							<div class="row align-items-center">
								<div class="col-12">
									<h3 class="mb-0">Editace kategorie</h3>
								</div>
							</div>
						</div>
						<div class="card-body bg-secondary">
							<form action="./" method="POST" id="edit-category">
								<h6 class="heading text-muted mb-4">Základní údaje</h6>
								<div class="pl-lg-4">
									<div class="row">
										<div class="col">
											<div class="form-group">
												<label class="form-control-label" for="name">Název</label>
												<input type="text" id="name" class="form-control" required
													value="<%= category.name %> "
													placeholder="Vyplňte prosím toto povinné pole, např. Muži 3B">
											</div>
										</div>
									</div>
								</div>
								<div class="row">
									<div class="col float-left">
										<h6 class="heading text-muted mb-4">Bodování</h6>
									</div>
									<div class="col float-right">
										<button type="button" onclick="addPlacementRow()"
											class="btn btn-sm btn-primary float-right">Přidat umístění</button>
									</div>
								</div>
								<div class="pl-lg-4">
									<div id="placements">
										<% category.placementPoints.forEach((placementPoint, i) => { %>
										<div class="row">
											<div class="col-md-6 col-sm-12">
												<div class="form-group">
													<label class="form-control-label"
														for="placement-<%= i %>">Umístění</label>
													<input type="number" min="1" id="placement-<%= i %>"
														class="form-control" value="<%= i+1 %>" required="required"
														placeholder="Vyplňte prosím toto povinné pole"
														value="<%= placementPoint.placement %>">
												</div>
											</div>
											<div class="col-md-5 col-sm-12">
												<div class="form-group">
													<label class="form-control-label"
														for="placement-points-<%= i %>">Počet bodů</label>
													<input type="number" min="0" id="placement-points-<%= i %>"
														class="form-control" required="required" value="<%= placementPoint.points %>"
														placeholder="Vyplňte prosím toto povinné pole">
												</div>
											</div>
											<div class="col-1 m-auto"><button class="btn btn-danger m-auto"
													type="button"
													onclick="$(this).parent().parent().remove()">×</button></div>
										</div>
										<% }) %>
									</div>
								</div>
								<div class="pl-lg-4">
									<div class="row">
										<div class="col" id="edit-category-status" style="display: none;"></div>
										<div class="col-4 text-left">
											<button type="submit" class="btn btn-primary">Editovat</button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<%- include('../partials/footer') %>
		</div>
	</div>
	<%- include('../partials/scripts-file-end') %>
	<script>
		function addPlacementRow(i = $('div#placements .row').length, motherDOM = $('div#placements')) {
			$('<div>', { class: 'row' }).append(
				$('<div>', { class: 'col-md-6 col-sm-12' }).append(
					$('<div>', { class: 'form-group' }).append(
						$('<label>', { class: 'form-control-label', for: `placement-${i}` }).text('Umístění'),
						$('<input>', { type: 'number', min: '1', id: `placement-${i}`, class: 'form-control', value: i + 1, required: 'required', placeholder: 'Vyplňte prosím toto povinné pole' })
					)
				),
				$('<div>', { class: 'col-md-5 col-sm-12' }).append(
					$('<div>', { class: 'form-group' }).append(
						$('<label>', { class: 'form-control-label', for: `placement-points-${i}` }).text('Počet bodů'),
						$('<input>', { type: 'number', min: '0', id: `placement-points-${i}`, class: 'form-control', required: 'required', placeholder: 'Vyplňte prosím toto povinné pole' })
					)
				),
				$('<div>', { class: 'col-1 m-auto' }).append(
					$('<button>', { class: 'btn btn-danger m-auto', type: 'button', onclick: '$(this).parent().parent().remove()' }).html('&times;')
				)
			).appendTo(motherDOM)
		}

		function getPlacementDataForRequest() {
			let placementPoints = []
			for (let i = 0; i < $('div#placements .row').length; i++) {
				placementPoints.push({
					placement: $(`input#placement-${i}`).val(),
					points: $(`input#placement-points-${i}`).val()
				})
			}
			return placementPoints
		}

		$(document).ready(() => {
			$('form#edit-category').submit(function (event) {
				event.preventDefault()
				let $status = $('div#edit-category-status')
				$status
					.empty()
					.append(
						$('<div>', { class: 'alert alert-default alert-dismissible fade show', role: 'alert' }).append(
							$('<span>', { class: 'alert-icon' }).append(
								$('<i>', { class: 'fas fa-circle-notch fa-spin' })
							),
							$('<span>', { class: 'alert-text' }).append(
								$('<strong>').text('Zpracovávám'),
								' Vyčkejte prosím'
							),
							$('<button>', { type: 'button', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'Close' }).append(
								$('<span>', { 'aria-hidden': 'true' }).html('&times;')
							)
						)
					)
					.show()

				API.category
					.edit('<%= category._id %>', $('input#name').val(), getPlacementDataForRequest())
					.done(function (responseFromServer) {
						if (responseFromServer === 'ok') {
							$status
								.empty()
								.append(
									$('<div>', { class: 'alert alert-success alert-dismissible' }).append(
										$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
										$('<strong>').text('Gratuluji!'),
										' Úspěšně jste upravil(a) kategorii'
									)
								)
								.show()

							// Reload page
							setTimeout(function () {
								window.location.href = window.location.href;
							}, 3500)
						} else {
							$status
								.empty()
								.append(
									$('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
										$('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
										$('<strong>').text('Ach ne! '),
										responseFromServer
									)
								)
								.show()
						}
					})
			})
		})
	</script>
	<%- include('../partials/file-end') %>